diff --git a/Rakefile b/Rakefile
index 9f5959cd..764def85 100644
--- a/Rakefile
+++ b/Rakefile
@@ -40,6 +40,14 @@ namespace :e2e do
   end
 end
 
+Rake::TestTask.new(:distribution) do |t|
+  t.libs << "test"
+  t.libs << "lib"
+  t.test_files = FileList["test/{release,install,acceptance}/**/*_test.rb"]
+  t.warning = false
+  t.description = "Run release, installer, package, prompt, and safety contracts"
+end
+
 desc "Run real-subprocess CLI/TUI e2e scenarios"
 task :e2e do
   ruby "bin/hive-e2e", "run"
diff --git a/assets/services/hive.service b/assets/services/hive.service
new file mode 100644
index 00000000..35a5249e
--- /dev/null
+++ b/assets/services/hive.service
@@ -0,0 +1,11 @@
+[Unit]
+Description=Hive pipeline daemon
+
+[Service]
+Type=simple
+ExecStart=@EXECUTABLE@ daemon start
+Restart=on-failure
+Environment=HIVE_STATE_DIR=@STATE_DIR@
+
+[Install]
+WantedBy=default.target
diff --git a/bin/hive b/bin/hive
index bfd53884..297cfe8c 100755
--- a/bin/hive
+++ b/bin/hive
@@ -1,6 +1,7 @@
 #!/usr/bin/env ruby
 
-$LOAD_PATH.unshift(File.expand_path("../lib", __dir__))
+resource_root = ENV.fetch("HIVE_RESOURCE_ROOT") { File.expand_path("..", __dir__) }
+$LOAD_PATH.unshift(File.join(resource_root, "lib"))
 
 require "hive"
 require "hive/cli"
diff --git a/lib/hive.rb b/lib/hive.rb
index 8db3300a..428254f6 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -1,5 +1,6 @@
+require "hive/version"
+
 module Hive
-  VERSION = "0.1.0".freeze
   MIN_CLAUDE_VERSION = "2.1.118".freeze
 
   module Schemas
diff --git a/lib/hive/assets.rb b/lib/hive/assets.rb
new file mode 100644
index 00000000..2277abf9
--- /dev/null
+++ b/lib/hive/assets.rb
@@ -0,0 +1,163 @@
+require "digest"
+require "fileutils"
+require "yaml"
+require "hive/paths"
+
+module Hive
+  module Assets
+    MANIFEST = ".hive/ownership.yml".freeze
+    module_function
+
+    def seed_shared!(source: nil, project_source: nil,
+                     destination: Hive::Paths.releases_dir, version: Hive::VERSION)
+      bundled_source = source.nil?
+      source ||= Hive::Paths.resource("assets", "shared")
+      project_source ||= Hive::Paths.resource("assets", "project") if bundled_source
+      target = File.join(destination, version)
+      if complete_release?(target)
+        switch_current!(destination, version)
+        return target
+      end
+
+      FileUtils.mkdir_p(destination)
+      temporary = File.join(destination, ".#{version}.tmp-#{Process.pid}")
+      FileUtils.rm_rf(temporary) if File.exist?(temporary)
+      FileUtils.mkdir_p(temporary)
+      copy_tree(source, temporary)
+      copy_tree(project_source, File.join(temporary, "project")) if project_source
+      File.write(File.join(temporary, ".complete"), "#{version}\n")
+      File.rename(temporary, target)
+      switch_current!(destination, version)
+      target
+    ensure
+      FileUtils.rm_rf(temporary) if defined?(temporary) && temporary && File.exist?(temporary)
+    end
+
+    def scaffold_project!(project_root, source: File.join(Hive::Paths.release_dir, "project"))
+      root = safe_project_root(project_root)
+      destination = File.join(root, ".hive")
+      manifest_path = File.join(root, MANIFEST)
+      ensure_safe_project_destination!(root, destination)
+      previous = load_manifest(manifest_path)
+      result = { created: [], conflicts: [] }
+      managed = previous.fetch("files", {})
+
+      source_files(source).each do |relative|
+        target = File.join(destination, relative)
+        project_relative = File.join(".hive", relative)
+        source_digest = digest(File.join(source, relative))
+        if File.exist?(target) || File.symlink?(target)
+          if safe_regular_file?(target) && managed[project_relative] == digest(target) && digest(target) == source_digest
+            next
+          end
+          result[:conflicts] << project_relative
+          next
+        end
+
+        ensure_safe_parent!(root, File.dirname(target))
+        FileUtils.mkdir_p(File.dirname(target))
+        FileUtils.cp(File.join(source, relative), target)
+        managed[project_relative] = digest(target)
+        result[:created] << project_relative
+      end
+
+      write_manifest(manifest_path, managed)
+      result
+    end
+
+    def safe_project_root(project_root)
+      root = File.realpath(File.expand_path(project_root))
+      unsafe = [ File::SEPARATOR, File.realpath(Dir.home) ]
+      raise Hive::ConfigError, "refusing unsafe project root: #{root}" if unsafe.include?(root)
+      raise Hive::ConfigError, "project root is not writable: #{root}" unless File.writable?(root)
+
+      root
+    rescue Errno::ENOENT
+      raise Hive::ConfigError, "project root does not exist: #{project_root}"
+    end
+
+    def source_files(source)
+      return [] unless File.directory?(source)
+
+      Dir.glob(File.join(source, "**", "*"), File::FNM_DOTMATCH)
+         .select { |path| File.file?(path) }
+         .map { |path| path.delete_prefix("#{source}/") }
+         .sort
+    end
+
+    def copy_tree(source, destination)
+      source_files(source).each do |relative|
+        target = File.join(destination, relative)
+        FileUtils.mkdir_p(File.dirname(target))
+        FileUtils.cp(File.join(source, relative), target)
+      end
+    end
+
+    def complete_release?(target)
+      File.directory?(target) && File.file?(File.join(target, ".complete"))
+    end
+
+    def switch_current!(destination, version)
+      pointer = File.join(destination, "current")
+      if File.exist?(pointer) && !File.symlink?(pointer)
+        raise Hive::ConfigError, "refusing to replace non-symlink release pointer: #{pointer}"
+      end
+      return if File.symlink?(pointer) && File.readlink(pointer) == version
+
+      temporary = File.join(destination, ".current-#{Process.pid}")
+      File.symlink(version, temporary)
+      File.rename(temporary, pointer)
+    ensure
+      FileUtils.rm_f(temporary) if defined?(temporary) && temporary
+    end
+
+    def load_manifest(path)
+      return { "version" => 1, "files" => {} } unless File.file?(path)
+
+      data = YAML.safe_load_file(path)
+      data.is_a?(Hash) && data["files"].is_a?(Hash) ? data : { "version" => 1, "files" => {} }
+    rescue Psych::Exception
+      { "version" => 1, "files" => {} }
+    end
+
+    def write_manifest(path, files)
+      raise Hive::ConfigError, "refusing symlinked ownership manifest: #{path}" if File.symlink?(path)
+
+      FileUtils.mkdir_p(File.dirname(path))
+      temporary = "#{path}.tmp-#{Process.pid}"
+      File.write(temporary, { "version" => 1, "files" => files.sort.to_h }.to_yaml)
+      File.rename(temporary, path)
+    ensure
+      FileUtils.rm_f(temporary) if defined?(temporary) && temporary
+    end
+
+    def safe_regular_file?(path)
+      File.file?(path) && !File.symlink?(path)
+    end
+
+    def digest(path)
+      Digest::SHA256.file(path).hexdigest
+    end
+
+    def ensure_safe_project_destination!(root, destination)
+      if File.symlink?(destination)
+        raise Hive::ConfigError, "refusing symlinked project scaffold directory: #{destination}"
+      end
+      return unless File.exist?(destination) && !File.directory?(destination)
+
+      raise Hive::ConfigError, "project scaffold path is not a directory: #{destination}"
+    end
+
+    def ensure_safe_parent!(root, parent)
+      hive_root = File.join(root, ".hive")
+      current = parent
+      while current.start_with?("#{hive_root}#{File::SEPARATOR}") || current == hive_root
+        raise Hive::ConfigError, "refusing symlinked project scaffold parent: #{current}" if File.symlink?(current)
+
+        break if current == hive_root
+
+        current = File.dirname(current)
+      end
+    end
+  end
+end
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index 9bc60cb8..c697e21f 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -63,9 +63,18 @@ module Hive
       See `wiki/commands/init.md` for the full prompt flow and ADR-023.
     DESC
     option :force, type: :boolean, default: false, desc: "skip clean-tree check"
+    option :provider, type: :string, desc: "first-run provider choice"
+    option :model, type: :string, desc: "first-run model choice"
+    option :credential_env, type: :string, desc: "environment variable containing provider credentials"
     def init(project_path = Dir.pwd)
       require "hive/commands/init"
-      Hive::Commands::Init.new(project_path, force: options[:force]).call
+      Hive::Commands::Init.new(
+        project_path,
+        force: options[:force],
+        provider: options[:provider],
+        model: options[:model],
+        credential_env: options[:credential_env]
+      ).call
     end
 
     desc "forget NAME", "Remove a project from the global registry (inverse of `hive init`)"
@@ -92,6 +101,25 @@ module Hive
       Hive::Commands::Forget.new(name, json: options[:json]).call
     end
 
+    desc "update", "Update Hive through its owning installation channel"
+    def update
+      require "hive/commands/update"
+      Hive::Commands::Update.new.call
+    end
+
+    desc "uninstall [PROJECT_PATH]", "Unregister Hive and remove the core through its owning channel"
+    option :project_cleanup, type: :boolean, default: false,
+                             desc: "remove only unmodified generated .hive files"
+    option :purge, type: :boolean, default: false,
+                   desc: "non-interactively remove known generated .hive files"
+    def uninstall(project_path = nil)
+      require "hive/commands/uninstall"
+      Hive::Commands::Uninstall.new(
+        project_root: project_path,
+        cleanup: options[:project_cleanup] || options[:purge]
+      ).call
+    end
+
     desc "prune", "Drop registry entries whose project path no longer exists"
     long_desc <<~DESC
       Walks ~/Dev/hive/config.yml and removes every `registered_projects`
diff --git a/lib/hive/command_name.rb b/lib/hive/command_name.rb
new file mode 100644
index 00000000..2455152d
--- /dev/null
+++ b/lib/hive/command_name.rb
@@ -0,0 +1,35 @@
+module Hive
+  module CommandName
+    module_function
+
+    def select(path: ENV.fetch("PATH", ""), installed_executable: $PROGRAM_NAME)
+      resolved = resolve("hive", path)
+      return "hive" unless resolved
+      return "hive" if same_file?(resolved, installed_executable)
+
+      "hv"
+    end
+
+    def resolve(command, path = ENV.fetch("PATH", ""))
+      path.split(File::PATH_SEPARATOR).each do |directory|
+        candidate = File.expand_path(command, directory.empty? ? "." : directory)
+        return candidate if File.file?(candidate) && File.executable?(candidate)
+      end
+      nil
+    end
+
+    def stable_executable(path: ENV.fetch("PATH", ""), current: $PROGRAM_NAME)
+      command = select(path: path, installed_executable: current)
+      resolve(command, path) || resolve(File.basename(current), path) || File.expand_path(current)
+    end
+
+    def same_file?(left, right)
+      return false unless right && File.exist?(right)
+
+      File.identical?(left, right)
+    rescue Errno::ENOENT
+      false
+    end
+    private_class_method :same_file?
+  end
+end
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index f88bca6f..bd576a00 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -44,14 +44,17 @@ module Hive
       end
 
       def initialize(subcommand, target = nil, detach: false, dry_run: false,
-                     all: false, json: false, hive_home: Hive::Config.hive_home)
+                     all: false, json: false, hive_home: nil)
         @subcommand = subcommand
         @target = target
         @detach = detach
         @dry_run = dry_run
         @all = all
         @json = json
-        @hive_home = hive_home
+        legacy_runtime_root = hive_home || ENV["HIVE_HOME"]
+        legacy_runtime_root = nil if legacy_runtime_root&.empty?
+        @hive_home = legacy_runtime_root || Hive::Config.hive_home
+        @legacy_runtime_root = legacy_runtime_root
       end
 
       def call
@@ -72,11 +75,19 @@ module Hive
       end
 
       def pid_file
-        @pid_file ||= File.join(@hive_home, ".daemon.pid")
+        @pid_file ||= if @legacy_runtime_root
+                        File.join(@legacy_runtime_root, ".daemon.pid")
+        else
+          File.join(Hive::Paths.runtime_dir, "daemon.pid")
+        end
       end
 
       def log_file
-        @log_file ||= File.join(@hive_home, "logs", "daemon.log")
+        @log_file ||= if @legacy_runtime_root
+                        File.join(@legacy_runtime_root, "logs", "daemon.log")
+        else
+          File.join(Hive::Paths.state_dir, "logs", "daemon.log")
+        end
       end
 
       private
@@ -84,6 +95,7 @@ module Hive
       def start_daemon
         warn_unsupported_json_flag if @json
         FileUtils.mkdir_p(@hive_home)
+        FileUtils.mkdir_p(File.dirname(pid_file))
         FileUtils.mkdir_p(File.dirname(log_file))
 
         # Single-instance check: if a live daemon already owns the PID
diff --git a/lib/hive/commands/init.rb b/lib/hive/commands/init.rb
index b86e8d61..2c59c699 100644
--- a/lib/hive/commands/init.rb
+++ b/lib/hive/commands/init.rb
@@ -5,13 +5,19 @@ require "hive/config"
 require "hive/git_ops"
 require "hive/commands/init/prompts"
 require "hive/commands/doctor"
+require "hive/assets"
+require "hive/dependency_check"
+require "hive/service"
 
 module Hive
   module Commands
     class Init
-      def initialize(project_path, force: false, prompts: nil)
+      def initialize(project_path, force: false, prompts: nil, provider: nil, model: nil, credential_env: nil)
         @project_path = File.expand_path(project_path)
         @force = force
+        @provider = provider
+        @model = model
+        @credential_env = credential_env
         # Optional Prompts instance for testability. Tests inject a
         # pre-fed StringIO-backed instance to drive the interactive flow
         # without touching $stdin. Production keeps this nil so the
@@ -22,14 +28,15 @@ module Hive
       end
 
       def call
+        print_dependency_diagnostics
         validate_git_repo!
-        validate_clean_tree! unless @force
 
         ops = Hive::GitOps.new(@project_path)
         if ops.hive_state_branch_exists?
-          raise Hive::AlreadyInitialized,
-                "already initialized; hive/state branch present at #{@project_path}"
+          repair_existing_install!(ops)
+          return
         end
+        validate_clean_tree! unless @force
 
         # Prompt placement is load-bearing (per ADR-023): runs AFTER the
         # already-initialized guard above, BEFORE any disk writes below.
@@ -37,13 +44,73 @@ module Hive
         # no orphan branch, no worktree, no master .gitignore update —
         # so a re-run of `hive init` proceeds normally.
         answers = collect_prompt_answers
+        provider_values = provider_values(answers)
+        Hive::Config.provider_config_data(**provider_values)
+        validate_project_destination!
+        Hive::Config.write_provider_config!(**provider_values)
 
         ops.hive_state_init
         write_per_project_config(ops, answers: answers)
+        seed_install_assets!
         ops.add_hive_state_to_master_gitignore!
 
         entry = Hive::Config.register_project(name: File.basename(@project_path), path: @project_path)
+        register_user_service!(start: answers.fetch("daemon_enabled", false))
+
+        print_summary(entry: entry, ops: ops)
+        run_init_preflight!
+      end
+
+      def seed_install_assets!
+        legacy_home = ENV["HIVE_HOME"]
+        destination = legacy_home && !legacy_home.empty? ? File.join(legacy_home, "data", "releases") : Hive::Paths.releases_dir
+        release = Hive::Assets.seed_shared!(destination: destination)
+        result = Hive::Assets.scaffold_project!(@project_path, source: File.join(release, "project"))
+        result[:conflicts].each { |path| write_warn("hive: preserving existing or modified #{path}") }
+      end
+
+      def provider_values(answers)
+        supplied = [ @provider, @model, @credential_env ]
+        if supplied.any? && !supplied.all?
+          raise Hive::ConfigError, "provider, model, and credential-env must be supplied together"
+        end
+
+        {
+          provider: @provider || answers.fetch("provider"),
+          model: @model || answers.fetch("model"),
+          credential_env: @credential_env || answers.fetch("credential_env")
+        }
+      end
 
+      def validate_project_destination!
+        root = Hive::Assets.safe_project_root(@project_path)
+        Hive::Assets.ensure_safe_project_destination!(root, File.join(root, ".hive"))
+      end
+
+      def print_dependency_diagnostics
+        Hive::DependencyCheck.call.each do |row|
+          next unless row[:status] == :missing
+
+          write_warn("hive: dependency #{row[:name]} is missing. #{row[:hint]}")
+        end
+      end
+
+      def register_user_service!(start:)
+        return if ENV["HIVE_HOME"] && !ENV["HIVE_HOME"].empty?
+
+        service = Hive::Service.current
+        service.register
+        service.start if start
+      end
+
+      def repair_existing_install!(ops)
+        ops.hive_state_init
+        validate_project_destination!
+        seed_install_assets!
+        config = Hive::Config.load(@project_path)
+        ops.add_hive_state_to_master_gitignore!
+        entry = Hive::Config.register_project(name: File.basename(@project_path), path: @project_path)
+        register_user_service!(start: config.dig("daemon", "enabled") == true)
         print_summary(entry: entry, ops: ops)
         run_init_preflight!
       end
diff --git a/lib/hive/commands/init/prompts.rb b/lib/hive/commands/init/prompts.rb
index 088635f9..65d364ba 100644
--- a/lib/hive/commands/init/prompts.rb
+++ b/lib/hive/commands/init/prompts.rb
@@ -26,6 +26,9 @@ module Hive
         DEFAULT_PLANNING_AGENT = "claude".freeze
         DEFAULT_DEVELOPMENT_AGENT = "codex".freeze
         DEFAULT_TRIAGE_BIAS = "courageous".freeze
+        DEFAULT_PROVIDER = "openai".freeze
+        DEFAULT_MODEL = "gpt-5".freeze
+        DEFAULT_CREDENTIAL_ENV = "OPENAI_API_KEY".freeze
         TRIAGE_BIASES = %w[courageous safetyist].freeze
 
         # Reviewer entries shipped in templates/project_config.yml.erb. The
@@ -109,6 +112,9 @@ module Hive
           triage_bias = prompt_triage_bias
           budgets, timeouts = prompt_limits
           daemon_enabled = prompt_daemon_enabled
+          provider = prompt_value("Provider", DEFAULT_PROVIDER)
+          model = prompt_value("Model", DEFAULT_MODEL)
+          credential_env = prompt_value("Credential environment variable", DEFAULT_CREDENTIAL_ENV)
 
           answers = {
             "planning_agent" => planning,
@@ -117,7 +123,10 @@ module Hive
             "triage_bias" => triage_bias,
             "budgets" => budgets,
             "timeouts" => timeouts,
-            "daemon_enabled" => daemon_enabled
+            "daemon_enabled" => daemon_enabled,
+            "provider" => provider,
+            "model" => model,
+            "credential_env" => credential_env
           }
 
           summarize(answers)
@@ -143,7 +152,10 @@ module Hive
             "triage_bias" => DEFAULT_TRIAGE_BIAS,
             "budgets" => default_budgets,
             "timeouts" => default_timeouts,
-            "daemon_enabled" => true
+            "daemon_enabled" => false,
+            "provider" => DEFAULT_PROVIDER,
+            "model" => DEFAULT_MODEL,
+            "credential_env" => DEFAULT_CREDENTIAL_ENV
           }
           # Goes to @summary_io (stdout by default) so a non-TTY caller's
           # `summary=$(hive init)` capture has a parseable single line.
@@ -151,7 +163,8 @@ module Hive
             "hive: using defaults — planning=#{DEFAULT_PLANNING_AGENT}, " \
             "dev=#{DEFAULT_DEVELOPMENT_AGENT}, " \
             "reviewers=all#{DEFAULT_REVIEWER_NAMES.size}, " \
-            "triage=#{DEFAULT_TRIAGE_BIAS}, limits=defaults, daemon=enabled"
+            "triage=#{DEFAULT_TRIAGE_BIAS}, limits=defaults, daemon=disabled, " \
+            "provider=#{DEFAULT_PROVIDER}, model=#{DEFAULT_MODEL}"
           )
           answers
         end
@@ -352,6 +365,16 @@ module Hive
           end
         end
 
+        def prompt_value(label, default)
+          loop do
+            @output.print "#{label} [#{default}]: "
+            @output.flush
+            answer = read_line
+            return default if answer.empty?
+            return answer unless answer.match?(/[\r\n]/)
+          end
+        end
+
         def summarize(answers)
           @output.puts ""
           @output.puts "Summary:"
@@ -361,6 +384,9 @@ module Hive
           @output.puts "  triage_bias       = #{answers['triage_bias']}"
           @output.puts "  limits            = #{summarize_limits(answers)}"
           @output.puts "  daemon            = #{answers['daemon_enabled'] ? 'enabled' : 'disabled'}"
+          @output.puts "  provider          = #{answers['provider']}"
+          @output.puts "  model             = #{answers['model']}"
+          @output.puts "  credential_source = env:#{answers['credential_env']}"
         end
 
         def summarize_limits(answers)
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
new file mode 100644
index 00000000..5abe1fdd
--- /dev/null
+++ b/lib/hive/commands/uninstall.rb
@@ -0,0 +1,101 @@
+require "digest"
+require "yaml"
+require "hive/install/channel"
+require "hive/install/receipt"
+require "hive/service"
+
+module Hive
+  module Commands
+    class Uninstall
+      def initialize(project_root: nil, cleanup: false, receipt_path: Hive::Paths.receipt_file, output: $stdout,
+                     receipt_loader: Hive::Install::Receipt.method(:load),
+                     channel_factory: Hive::Install::Channel.method(:new), service: nil)
+        @project_root = project_root && File.expand_path(project_root)
+        @cleanup = cleanup
+        @receipt_path = receipt_path
+        @output = output
+        @receipt_loader = receipt_loader
+        @channel_factory = channel_factory
+        @service = service
+      end
+
+      def call
+        receipt = @receipt_loader.call(@receipt_path)
+        channel = @channel_factory.call(receipt)
+        channel.verify_ownership!
+        plan = @cleanup && @project_root ? self.class.plan_project_cleanup(@project_root) : empty_cleanup_plan
+        print_preview(receipt, plan)
+        (@service || Hive::Service.current).unregister
+        channel.uninstall
+        self.class.apply_cleanup_plan(plan) if @cleanup && @project_root
+        true
+      end
+
+      def self.cleanup_project(project_root)
+        apply_cleanup_plan(plan_project_cleanup(project_root))
+      end
+
+      def self.plan_project_cleanup(project_root)
+        root = File.realpath(project_root)
+        manifest_path = File.join(root, ".hive", "ownership.yml")
+        return { candidates: [], preserved: [] } unless File.file?(manifest_path)
+
+        manifest = YAML.safe_load_file(manifest_path)
+        files = manifest.is_a?(Hash) && manifest["files"].is_a?(Hash) ? manifest["files"] : {}
+        files.each_with_object({ candidates: [], preserved: [] }) do |(relative, expected), result|
+          target = safe_owned_target(root, relative)
+          if target && File.file?(target) && !File.symlink?(target) && Digest::SHA256.file(target).hexdigest == expected
+            result[:candidates] << [ relative, target, expected ]
+          else
+            result[:preserved] << relative
+          end
+        end
+      rescue Psych::Exception, Errno::ENOENT
+        { candidates: [], preserved: [ ".hive/ownership.yml" ] }
+      end
+
+      def self.apply_cleanup_plan(plan)
+        plan.fetch(:candidates).each_with_object({ removed: [], preserved: plan.fetch(:preserved).dup }) do |entry, result|
+          relative, target, expected = entry
+          if File.file?(target) && !File.symlink?(target) && Digest::SHA256.file(target).hexdigest == expected
+            File.delete(target)
+            result[:removed] << relative
+          else
+            result[:preserved] << relative
+          end
+        end
+      end
+
+      def self.safe_owned_target(root, relative)
+        return unless relative.start_with?(".hive/")
+        return if File.symlink?(File.join(root, ".hive"))
+
+        target = File.expand_path(relative, root)
+        prefix = "#{File.join(root, '.hive')}#{File::SEPARATOR}"
+        return unless target.start_with?(prefix)
+
+        parent = File.dirname(target)
+        while parent.start_with?(prefix)
+          return if File.symlink?(parent)
+          parent = File.dirname(parent)
+        end
+        target
+      end
+
+      private
+
+      def empty_cleanup_plan
+        { candidates: [], preserved: [] }
+      end
+
+      def print_preview(receipt, plan)
+        @output.puts "hive: removing core through #{receipt['channel']} (#{receipt['package']})"
+        @output.puts "hive: will unregister the user service before core removal"
+        removals = plan[:candidates].map(&:first)
+        @output.puts "hive: will remove generated project files: #{removals.join(', ')}" unless removals.empty?
+        @output.puts "hive: will preserve project entries: #{plan[:preserved].join(', ')}" unless plan[:preserved].empty?
+        @output.puts "hive: XDG config/state, completed outputs, unknown project files, and agent skills are preserved"
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/update.rb b/lib/hive/commands/update.rb
new file mode 100644
index 00000000..a0cce500
--- /dev/null
+++ b/lib/hive/commands/update.rb
@@ -0,0 +1,22 @@
+require "hive/install/channel"
+require "hive/install/receipt"
+
+module Hive
+  module Commands
+    class Update
+      def initialize(receipt_path: Hive::Paths.receipt_file, output: $stdout)
+        @receipt_path = receipt_path
+        @output = output
+      end
+
+      def call
+        receipt = Hive::Install::Receipt.load(@receipt_path)
+        channel = Hive::Install::Channel.new(receipt)
+        channel.verify_ownership!
+        channel.update
+        @output.puts "hive: update delegated to #{receipt['channel']} (#{receipt['package']})"
+        true
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index a67097d8..f586be04 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -1,6 +1,7 @@
 require "yaml"
 require "fileutils"
 require "hive/agent_profiles"
+require "hive/paths"
 
 module Hive
   module Config
@@ -170,11 +171,11 @@ module Hive
         "codex_budget_usd" => 1,
         "codex_timeout_sec" => 120,
         "shutdown_grace_sec" => 60,
-        "pid_file" => "~/Dev/hive/.bot.pid",
-        "log_file" => "~/Dev/hive/logs/bot.log",
+        "pid_file" => nil,
+        "log_file" => nil,
         "log_max_bytes" => 10_485_760,
         "log_max_files" => 5,
-        "last_seen_state_file" => "~/Dev/hive/.bot.last_seen_update_id"
+        "last_seen_state_file" => nil
       },
       # Auto-rebase pre-step for `hive run` (plan
       # docs/plans/2026-05-14-001-feat-hive-auto-rebase-stale-worktree-plan.md).
@@ -209,13 +210,50 @@ module Hive
     module_function
 
     def hive_home
-      ENV["HIVE_HOME"] || File.expand_path("~/Dev/hive")
+      legacy = ENV["HIVE_HOME"]
+      legacy && !legacy.empty? ? File.expand_path(legacy) : Hive::Paths.config_dir
     end
 
     def global_config_path
       File.join(hive_home, "config.yml")
     end
 
+    def write_provider_config!(path: Hive::Paths.config_file, provider:, model:, credential_env:)
+      provider_data = provider_config_data(provider: provider, model: model, credential_env: credential_env)
+
+      FileUtils.mkdir_p(File.dirname(path))
+      temporary = "#{path}.tmp-#{Process.pid}"
+      data = File.file?(path) ? YAML.safe_load_file(path) : {}
+      raise ConfigError, "provider config at #{path} must be a mapping" unless data.nil? || data.is_a?(Hash)
+
+      data = (data || {}).merge(provider_data)
+      File.write(temporary, data.to_yaml, mode: "w", perm: 0o600)
+      File.chmod(0o600, temporary)
+      File.rename(temporary, path)
+      path
+    rescue Psych::Exception => e
+      raise ConfigError, "provider config at #{path} is not valid YAML: #{e.message}"
+    rescue SystemCallError => e
+      raise ConfigError, "provider config at #{path} could not be written: #{e.message}"
+    ensure
+      FileUtils.rm_f(temporary) if defined?(temporary) && temporary
+    end
+
+    def provider_config_data(provider:, model:, credential_env:)
+      if provider.to_s.strip.empty? || model.to_s.strip.empty?
+        raise ConfigError, "provider and model choices must be non-empty"
+      end
+      unless credential_env.to_s.match?(/\A[A-Z][A-Z0-9_]*\z/)
+        raise ConfigError, "credential source must be an environment variable name, not a secret value"
+      end
+
+      {
+        "provider" => provider.to_s,
+        "model" => model.to_s,
+        "credential_source" => "env:#{credential_env}"
+      }
+    end
+
     def hive_state_dir(project_root, hive_state_name = ".hive-state")
       File.join(project_root, hive_state_name)
     end
@@ -327,7 +365,7 @@ module Hive
     end
 
     # Load and validate the global `daemon` block from
-    # `~/Dev/hive/config.yml`. Returns the merged Hash (operator
+    # the XDG global config. Returns the merged Hash (operator
     # overrides on top of `Config::DEFAULTS["daemon"]`). Used by
     # `hive daemon start` / `reload` so operator knobs in the global
     # config (max_concurrent_runs, poll_interval_sec, log_*, etc.)
@@ -355,7 +393,7 @@ module Hive
       merged
     end
 
-    # Load and validate the global `bot` block from ~/Dev/hive/config.yml.
+    # Load and validate the global `bot` block from the XDG global config.
     # `require_runtime: true` is used by `hive bot start` so the opt-in
     # credentials fail loudly there without making read-only commands like
     # `hive status` require a Telegram token.
@@ -386,9 +424,16 @@ module Hive
 
     def global_bot_defaults
       defaults = deep_dup(DEFAULTS["bot"])
-      defaults["pid_file"] = File.join(hive_home, ".bot.pid")
-      defaults["log_file"] = File.join(hive_home, "logs", "bot.log")
-      defaults["last_seen_state_file"] = File.join(hive_home, ".bot.last_seen_update_id")
+      legacy = ENV["HIVE_HOME"]
+      if legacy && !legacy.empty?
+        defaults["pid_file"] = File.join(hive_home, ".bot.pid")
+        defaults["log_file"] = File.join(hive_home, "logs", "bot.log")
+        defaults["last_seen_state_file"] = File.join(hive_home, ".bot.last_seen_update_id")
+      else
+        defaults["pid_file"] = File.join(Hive::Paths.runtime_dir, "bot.pid")
+        defaults["log_file"] = File.join(Hive::Paths.state_dir, "logs", "bot.log")
+        defaults["last_seen_state_file"] = File.join(Hive::Paths.state_dir, "bot.last_seen_update_id")
+      end
       defaults
     end
 
